/*******************************************************************************
*  skSPIlib.c - rohʐMs֐Cu(PUrbglbtp)           *
*                                                                              *
*    SPI_Init            - roh[h(}X^[)̐ݒƏs      *
*    SPI_setDataMode     - roh̓][hݒs                    *
*    SPI_setClockDivider - roh̒ʐMxݒs                      *
*    SPI_transfer        - rohʐMł̃f[^Mƃf[^Ms      *
*                                                                              *
*    FSDIs͕KufW^̓svɐݒsĉB             *
*          gpSS(CS)s͏HIGHɂ܂B                        *
*          SPI2𗘗pꍇ́AskSPIlib.h"#define SPI_MSSP2_USE"錾 *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2015-07-30  ޒH[            Create                            *
*  1.10    2016-06-14  ޒH[(ނ)  SPI_MODECKE(NbNʑ)ύX *
*  1.20    2019-01-08  ޒH[(ނ)  PIC24FmF                    *
* ============================================================================ *
*  PIC24E(24EP256MC202) PIC24F(24FJ64GB002)                                    *
*  MPLAB X(v4.10)                                                              *
*  MPLAB(R) XC16 C Compiler Version 1.30                                       *
*******************************************************************************/
#include <xc.h>
#include "skSPIlib.h"

/*******************************************************************************
*  SPI_Init(mode,divider,sdo)                                                  *
*    roh[h̐ݒ(}X^[)Əs                            *
*    SPI_CLOCK_DIV1ɂꍇ́AZJ_vXP[ 1:1ȊOɐݒ肵܂B*
*                                                                              *
*    mode :   SPI̓][hݒ肵܂(NbNɐƃNbNʑ̑g)  *
*             SPI_MODE1 = ɐ(0:LOW)  ʑ(0:ACh0VŁA0V->5Vɕωœ])*
*             SPI_MODE0 = ɐ(0:LOW)  ʑ(1:ACh0VŁA5V->0Vɕωœ])*
*             SPI_MODE3 = ɐ(1:HIGH) ʑ(0:ACh5VŁA5V->0Vɕωœ])*
*             SPI_MODE2 = ɐ(1:HIGH) ʑ(1:ACh5VŁA0V->5Vɕωœ])*
*    divider :SPI̒ʐMxݒ肵܂(vC}vXP[)                *
*             SPI_PPRE_DIV4   = 4:1  (FCY/4)/ZJ_vXP[            *
*             SPI_PPRE_DIV16  = 16:1 (FCY/16)/ZJ_vXP[           *
*             SPI_PPRE_DIV64  = 64:1 (FCY/64)/ZJ_vXP[           *
*    sdo :    gpSDOM̃sԍw肷(gp)                      *
*******************************************************************************/
void SPI_Init(char mode,char divider,int sdo)
{
     int con ;

     // }X^[[hA8rbgʐMASPI_MODE1AZJ_vXP[ 1:1ASPI_PPRE_DIV64
     con  = 0b0010000000111100 ;
     con  = con | divider ;    // w̃NbNx(vC}vXP[)ݒ肷
     if (mode == SPI_MODE0 || mode == SPI_MODE2) {
          con = con | 0x0100 ; // w̃NbNʑݒ肷(NbNʑ1Ƃ)
     }
     if (mode == SPI_MODE2 || mode == SPI_MODE3) {
          con = con | 0x0040 ; // w̃NbNɐݒ肷(ɐHIGHƂ)
     }
     SPI_CON1 = con ;
     SPI_STAT_SPIEN  = 1 ;     // SPIL
     SPI_IF  = 0 ;             // SPI̊݃tO
}
/*******************************************************************************
*  SPI_setDataMode(mode)                                                       *
*    roh̓][hݒs                                          *
*    mode :   SPI̓][hݒ肵܂(NbNɐƃNbNʑ̑g)  *
*******************************************************************************/
void SPI_setDataMode(char mode)
{
     if (mode == SPI_MODE0 || mode == SPI_MODE2) {
          SPI_CON1 = SPI_CON1 | 0x0100 ; // w̃NbNʑPݒ肷
     } else {
          SPI_CON1 = SPI_CON1 & 0xFEFF ; // w̃NbNʑOݒ肷
     }
     if (mode == SPI_MODE2 || mode == SPI_MODE3) {
          SPI_CON1 = SPI_CON1 | 0x0040 ; // w̃NbNɐHIGHݒ肷
     } else {
          SPI_CON1 = SPI_CON1 & 0xFFBF ; // w̃NbNɐLOWݒ肷
     }
}
/*******************************************************************************
*  SPI_setClockDivider(divider1,divider2)                                      *
*    roh̒ʐMxݒs                                            *
*    vC}vXP[ 1:1ƃZJ_vXP[ 1:1̑gݍ킹͔*
*    divider1 :vC}vXP[ݒ肷                                *
*    divider2 :ZJ_vXP[ݒ肷                                *
*******************************************************************************/
void SPI_setClockDivider(char divider1,char divider2)
{
     SPI_CON1 = (SPI_CON1 & 0xFFE3)  | divider1 ;    // vC}vXP[ݒ肷
     SPI_CON1 = (SPI_CON1 & 0xFFFC)  | divider2 ;    // ZJ_vXP[ݒ肷
}
/*******************************************************************************
*  ans = SPI_transfer(dt)                                                      *
*    rohʐMł̃f[^Mƃf[^Ms                            *
*    PUrbgʐM̏ꍇ͉܂傤(char -> int)                         *
*                                                                              *
*    dt  : Wrbg̑Mf[^w肵܂                                *
*    ans : Wrbg̎Mf[^Ԃ܂                                  *
*******************************************************************************/
unsigned char SPI_transfer(char dt)
{
     SPI_BUF = dt ;                     // f[^̑M
     while(SPI_IF == 0) ;               // M҂
     SPI_IF = 0 ;                       // tONA
     return SPI_BUF ;                   // f[^̎M
}
